# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define jws 24

%bcond_with tools
%if "%{?rhel}" == "6"
%bcond_without zips
%else
%bcond_with zips
%endif

%{!?aprconf: %{expand: %%define aprconf %{_bindir}/apr-config}}
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs24}}
%if "%{?rhel}" == "6"
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-jws3-1/build/libtool}}
%else
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-1/build/libtool}}
%endif
%define aprincludes %(%{aprconf} --includes 2>/dev/null)

Name:      mod_jk
Epoch:     0
Version:   1.2.40
Release:   8.redhat_1%{?dist}
Summary:   Tomcat mod_jk connector for Apache

Group:     Internet/WWW/Servers
License:   ASL 2.0
URL:       http://tomcat.apache.org
Source0:   http://www.apache.org/dist/tomcat/tomcat-connectors/jk/tomcat-connectors-%{version}-src.tar.gz
Source1:   %{name}.conf.sample
Source2:   uriworkermap.properties.sample
Source3:   workers.properties.sample
Patch0:    tomcat-connectors-1.2.40-BZ1100602.patch
Patch1:    mod_jk-CVE-2014-8111.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: httpd%{jws}-devel
%if "%{?rhel}" == "7"
# 64 bit only natives on RHEL 7
ExcludeArch:   i386 i686
%endif
BuildRequires: perl
BuildRequires: ant
%if "%{?rhel}" == "6"
BuildRequires: java7-devel >= 1.6.0
%else
BuildRequires: java-devel >= 1.6.0
%endif
BuildRequires: jpackage-utils >= 0:1.5.38
BuildRequires: libtool
BuildRequires: xalan-j2 >= 2.7.0
BuildRequires: zip

%description
Mod_jk is a replacement to the elderly mod_jserv. It is a completely new
Tomcat-Apache plug-in that handles the communication between Tomcat and Apache.

%package ap24
Summary: Tomcat %{name} connector for Apache 2.4.x
Group: Internet/WWW/Servers
Provides: %{name} = %{epoch}:%{version}-%{release}
Obsoletes: tomcat-mod
Obsoletes: %{name}-ap20 < %{epoch}:%{version}
Obsoletes: %{name}-ap22 < %{epoch}:%{version}
Obsoletes: mod_jk-tools < %{epoch}:%{version}-%{release}
Requires: httpd%{jws} >= 2.4.6

%description ap24
Tomcat %{name} connector for Apache 2.4.x.

%package manual
Summary: Tomcat %{name} connector manual
Group: Internet/WWW/Servers

%description manual
Tomcat %{name} connector manual.

%if %with tools
%package tools
Group: Internet/Log Analysis
Summary: Analysis and report tools for %{name}

%description tools
Miscellaneous %{name} analysis and report tools.
%endif

%if %with zips
%package src-zip
Summary:     Container for the sources of the Tomcat %{name} connector.
Group:       Development

%description src-zip
Container for the sources of the Tomcat %{name} connector.
%endif

%prep
%setup -q -n tomcat-connectors-%{version}-src
%patch0 -p1 -b .bz1100602
%patch1 -p0 -b .cve-2014-8111

%{__sed} -i -e 's|^(APXSCPPFLAGS=.*)$|$1 %{aprincludes}|' \
    native/common/Makefile.in

%build
%if %with zips
zip -q -r ../mod_jk-%{version}-src.zip *
%endif

pushd native
    [ -x ./configure ] || sh ./buildconf.sh
    %configure \
        --with-apxs="%{_sbindir}/apxs24"
    export LIBTOOL="`%{_sbindir}/apxs24 -q LIBTOOL 2>/dev/null`"
    # Handle old apxs (without -q LIBTOOL), eg Red Hat 8.0 and 9.
        if test -z "$LIBTOOL"; then
            LIBTOOL="%{libtool}"
        fi
    make %{?_smp_mflags} \
    LIBTOOL="$LIBTOOL" \
    EXTRA_CFLAGS="$RPM_OPT_FLAGS" \
    EXTRA_CPPFLAGS="%{aprincludes}"

popd
pushd xdocs
    CLASSPATH="$(build-classpath xalan-j2-serializer)" %ant
popd

%install
%{!?aprconf: %{expand: %%define aprconf %{_bindir}/apr-config}}
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs24}}
%if "%{?rhel}" == "6"
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-jws3-1/build/libtool}}
%else
%{!?libtool: %{expand: %%define libtool %{_libdir}/apr-1/build/libtool}}
%endif
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define apconfdir %(%{apxs} -q SYSCONFDIR 2>/dev/null)
%define aplogdir logs
%define aprincludes %(%{aprconf} --includes 2>/dev/null)
%define tc5dir %{_datadir}/tomcat5
%{__rm} -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/httpd%{jws}/conf.d/
install -p -m 0644 %{SOURCE1} %{SOURCE2} %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/httpd%{jws}/conf.d/
%{__mkdir} -p _ap20
%{__sed} -i -e 's|/usr/local/bin\b|%{_bindir}|' tools/reports/*.pl
command="s|/usr/local/bin\b|%{_bindir}|"
%{__sed} -i -e $command tools/reports/*.pl
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{aplibdir}
%{__install} -p -m 0755 native/apache-2.0/%{name}.so \
        ${RPM_BUILD_ROOT}/%{aplibdir}/%{name}.so
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_var}/run/%{name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}/%{_var}/cache/%{name}
# for tools
%if %with tools
%{__install} -p -m 0755 tools/reports/*.pl ${RPM_BUILD_ROOT}/%{_bindir}
%endif

%if %with zips
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} ../mod_jk-%{version}-src.zip  ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/mod_jk-%{version}-src.zip
%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files ap24
%{!?apxs: %{expand: %%define apxs %{_sbindir}/apxs24}}
%define aplibdir %(%{apxs} -q LIBEXECDIR 2>/dev/null)
%defattr(-,root,root,-)
%doc LICENSE NOTICE
%doc native/README.txt native/TODO.txt
%{aplibdir}/*
%config(noreplace) %{_sysconfdir}/httpd%{jws}/conf.d/*
%dir %{_var}/run/%{name}
%dir %{_var}/cache/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc build/docs/*

%if %with tools
%files tools
%defattr(-,root,root,-)
%doc tools/reports/README.txt
%{_bindir}/*
%endif

%if %with zips
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/mod_jk-%{version}-src.zip
%endif

%changelog
* Wed May 27 2015 Jean-Frederic Clere <jclere@redhat.com> - 0:1.2.40-8.redhat_1
- JWS-24 Add missing patches.

* Tue Mar 03 2015  Weinan Li <weli@redhat.com> - 0:1.2.40-7.redhat_1
- JWS-14

* Mon Dec 15 2014  Permaine Cheung <pcheung@redhat.com> - 0:1.2.40-6.redhat_1
- Rebuild

* Wed Oct 15 2014  Permaine Cheung <pcheung@redhat.com> - 0:1.2.40-4.redhat_1
- Build against httpd24 on RHEL 6, 7

* Wed Sep 24 2014  Permaine Cheung <pcheung@redhat.com> - 0:1.2.40-3.redhat_1
- JWS 3.0 build
